<!--
 * @Author: lzhe lzhe@example.com
 * @Date: 2024-04-26 09:36:18
 * @LastEditors: lzhe lzhe@example.com
 * @LastEditTime: 2024-05-14 18:30:07
 * @FilePath: /smart-web/src/views/mdc/status-record.vue
 * @Description: 这是默认设置,请设置`customMade`, 打开koroFileHeader查看配置 进行设置: https://github.com/OBKoro1/koro1FileHeader/wiki/%E9%85%8D%E7%BD%AE
-->
<template>
	<div class="aposcope-main">
		<div class="aposcope-left">
			<div class="left-title">查询条件</div>
			<div class="left-title-col">日期</div>
            <el-date-picker v-model="time" type="daterange" :shortcuts="shortcuts" range-separator="-" size="small" style="width: 100%;" value-format="YYYY-MM-DD"/>
            <div class="left-title-col">工位</div>
            <el-button-group >
                <el-button @click="changeLeftTab(item)" :type="btnLeftctive == item.id ? 'primary' : ''" v-for="item in btnLeftList" :key="item.id" size="small">{{item.title }}</el-button>
            </el-button-group>
            <div class="MYTree">
                <MYTree v-if="btnLeftctive == '1'" getAll v-model="treeChecked" show-checkbox class="MYTree-content"></MYTree>
                <el-tree v-if="btnLeftctive == '2'" :data="tree2" :expand-on-click-node="false" default-expand-all show-checkbox :props="{label: 'name', children: 'children'}" class="treeActive" @check="treeListNode" />
            </div>
            <div class="footer">
                <el-button @click="query" type="primary">查询</el-button>
                <el-button @click="exportData">导出</el-button>
            </div>
		</div>
		<div class="aposcope-right">
            <el-tabs tab-position="top" v-model="activeName" type="card" @tab-change="tabChange">
                <el-tab-pane label="按班次统计" name="shift">
                    <!-- 日期 -->
                    <el-button-group>
                        <el-button @click="changeTab(item)" :type="btnListActive == item.id ? 'primary' : ''" v-for="item in btnList" :key="item.id" size="small">{{item.title }}</el-button>
                    </el-button-group>
                    <div class="fact-analysis-realtim" v-if="setTitle.length == 0">
                        <div class="wimi-empty"  v-if="isshowempty" style="background-color: rgb(255, 255, 255);">
                            <div class="wimi-empty-img" style="width: 150px; height: 150px;">
                                <img src="./quesheng.bd026700.png" style="height: auto; width: 100%;">
                            </div>
                            <div class="empty-description">
                                <div>暂无数据</div>
                            </div>
                        </div>
                    </div>
                    <!-- 按班次统计charts -->
                    <div id="analysisA" v-if="setTitle.length != 0">
                        <div class="demo-collapse">
                            <el-collapse v-model="activeNames" accordion>
                            <el-collapse-item v-for="(item,index) in setTitle" :name="index + 1">
                                <template #title>
                                    <el-icon size="16" color="#3b8e8e"><Memo /></el-icon>
                                    <span class="collr-title">班次{{index + 1}}</span>
                                    <el-button size="small">{{item.indexName}}</el-button>
                                </template>
                                <div>
                                    <!-- charts -->
                                    <div :id="'recordwork' + item.shiftIndex" style="height:300px;"></div>
                                </div>
                            </el-collapse-item>
                            </el-collapse>
                        </div>
                        <!-- <div class="paginationwork">
                            <el-pagination layout="prev, pager, next" @current-change="recordChange" :total="total" :default-page-size="6"/>
                        </div> -->
                    </div>
                </el-tab-pane>
                <el-tab-pane label="按时间周期统计" name="time">
                    <div class="fact-analysis-realtim" v-if="setTitle.length == 0">
                        <div class="wimi-empty"  v-if="isshowempty" style="background-color: rgb(255, 255, 255);">
                            <div class="wimi-empty-img" style="width: 150px; height: 150px;">
                                <img src="./quesheng.bd026700.png" style="height: auto; width: 100%;">
                            </div>
                            <div class="empty-description">
                                <div>暂无数据</div>
                            </div>
                        </div>
                    </div>
                    <!-- 按时间周期统计charts -->
                    <div id="analysisA" v-if="setTitle.length != 0">
                        <div class="demo-collapse">
                            <el-collapse v-model="activeNames1" accordion>
                                <el-collapse-item v-for="(item,index) in setTitle1" :name="index + 1">
                                    <template #title>
                                        <el-icon size="16" color="#3b8e8e"><Memo /></el-icon>
                                        <span class="collr-title">{{item.name}}</span>
                                        <el-button size="small" v-if="index != 0">{{item.indexName}}</el-button>
                                    </template>
                                    <div>
                                        <el-button-group>
                                            <el-button @click="changeTabB(item1,index,index1)" :type="item.btnListActive == item1.id ? 'primary' : ''" v-for="(item1,index1) in item.btnList" :key="item1.id" size="small">{{item1.title }}</el-button>
                                        </el-button-group>
                                        <!-- charts -->
                                        <div :id="'chartsB' + index" style="height:300px;"></div>
                                    </div>
                                </el-collapse-item>
                            </el-collapse>
                        </div>
                        <!-- <div class="paginationwork">
                            <el-pagination layout="prev, pager, next" @current-change="recordChange" :total="total" :default-page-size="6"/>
                        </div> -->
                    </div>
                </el-tab-pane>
            </el-tabs>
		</div>
	</div>
</template>

<script>
import * as ElementPlusIconsVue from '@element-plus/icons-vue'
let icons = []
for (const [key, component] of Object.entries(ElementPlusIconsVue)) {
    icons.push(key)
}
import * as echarts from 'echarts';
import moment from 'moment';
import MYTree from './MYTree.vue';
export default {
    components: {
        ...ElementPlusIconsVue,MYTree
    },
    data() {
        return {
            treeListNodeList: [],
            ids: [],
            activeNames: [],
            activeNames1: [1,2,3],
            current: "1",
            size: "10",
            total: "0",
        	setTitle: [],
            setTitle1: [],
        	date: "",
        	btnListActive: "",
        	tree2: [],
        	btnList: [],
        	btnLeftList: [{title: "按工位统计",id:"1"},{title: "按工位组统计",id:"2"}],
        	btnLeftctive: "1",
            isshowempty: true,
            getGlobalColorList: [],
            shortcuts: [
                {
                    text: '最近3天',
                    value: () => {
                    const end = new Date()
                    const start = new Date()
                    start.setDate(start.getDate() - 3)
                    return [start, end]
                    },
                },
                {
                    text: '最近7天',
                    value: () => {
                    const end = new Date()
                    const start = new Date()
                    start.setMonth(start.getDate() - 7)
                    return [start, end]
                    },
                },
                {
                    text: '最近一个月',
                    value: () => {
                    const end = new Date()
                    const start = new Date()
                    start.setMonth(start.getMonth() - 1)
                    return [start, end]
                    },
                },
            ],
            activeName: 'shift',
            time: [],
            workstationId: "",
            treeChecked: [],
            chartOptionA: {
                tooltip: {
                    trigger: 'axis',
                    axisPointer: {
                        type: 'shadow' // 'shadow' as default; can also be 'line' or 'shadow'
                    },
                    formatter: function (params) {
                        var dom = `<div>${params[0].name}</div>`;
                        params.forEach(item=> {
                            dom += `<div>${item.marker}${item.seriesName}：${item.data}%</div>`
                        })
                        console.log(params)
                        return dom;
                    }
                },
                grid: {
                    left: '3%',
                    right: '4%',
                    bottom: '3%',
                    containLabel: true
                },
                xAxis: {
                    type: 'category',
                    data: []
                },
                yAxis: {
                    type: 'value',
                    show: true,
                    axisLabel: {
                        formatter: function (value) {
                            return value + "%";
                        }
                    },
                    data: [2,20,40,60,80,100]
                },
                series: []
            },
            chartOptionB1: {
                tooltip: {
                    trigger: 'axis',
                    axisPointer: {
                        type: 'shadow' // 'shadow' as default; can also be 'line' or 'shadow'
                    },
                    formatter: function (params) {
                        var dom = `<div>${params[0].name}</div>`;
                        params.forEach(item=> {
                            dom += `<div>${item.marker}${item.seriesName}：${item.data}%</div>`
                        })
                        return dom;
                    }
                },
                grid: {
                    left: '3%',
                    right: '4%',
                    bottom: '3%',
                    containLabel: true
                },
                xAxis: {
                    type: 'category',
                    data: []
                },
                yAxis: {
                    type: 'value',
                    show: true,
                    axisLabel: {
                        formatter: function (value) {
                            return value * 100 + "%";
                        }
                    },
                    data: [2,20,40,60,80,100]
                },
                series: []
            },
            chartOptionB2: {
                tooltip: {
                    trigger: 'axis',
                    axisPointer: {
                        type: 'shadow' // 'shadow' as default; can also be 'line' or 'shadow'
                    },
                    formatter: function (params) {
                        var dom = `<div>${params[0].name}</div>`;
                        params.forEach(item=> {
                            dom += `<div>${item.marker}${item.seriesName}：${item.data}%</div>`
                        })
                        return dom;
                    }
                },
                grid: {
                    left: '3%',
                    right: '4%',
                    bottom: '3%',
                    containLabel: true
                },
                xAxis: {
                    type: 'category',
                    data: []
                },
                yAxis: {
                    type: 'value',
                    show: true,
                    axisLabel: {
                        formatter: function (value) {
                            return value * 100 + "%";
                        }
                    },
                    data: [2,20,40,60,80,100]
                },
                series: []
            },
            chartOptionB3: {
                tooltip: {
                    trigger: 'axis',
                    axisPointer: {
                        type: 'shadow' // 'shadow' as default; can also be 'line' or 'shadow'
                    },
                    formatter: function (params) {
                        var dom = `<div>${params[0].name}</div>`;
                        params.forEach(item=> {
                            dom += `<div>${item.marker}${item.seriesName}：${item.data}%</div>`
                        })
                        return dom;
                    }
                },
                grid: {
                    left: '3%',
                    right: '4%',
                    bottom: '3%',
                    containLabel: true
                },
                xAxis: {
                    type: 'category',
                    data: []
                },
                yAxis: {
                    type: 'value',
                    show: true,
                    axisLabel: {
                        formatter: function (value) {
                            return value * 100 + "%";
                        }
                    },
                    data: [2,20,40,60,80,100]
                },
                series: []
            }
        }
    },
    created() {
        
    },
    mounted() {
        this.init();
        this.getTree2List();  //按工位统计树
        this.getDataA();
        this.getGlobal(); //获取颜色
    },
    methods: {
        getGlobal() {
            this.$HTTP.get(`/api/blade-cps/global_wcs/list`).then(res=> {
                if(res.code == 200) {
                    this.getGlobalColorList = res.data;
                }
            })
        },
    	getDataA() {
            if(this.btnLeftctive == 1) {  //按工位统计
                var obj = {
                    ids: this.ids,
                    localDate: this.date,
                    type: 0
                }
            }else if(this.btnLeftctive == 2) { //按工位组统计
                var obj = {
                    groupCategory: 1,
                    groupType: "group_workstation",
                    ids: this.ids,
                    localDate: this.date,
                    type: 1
                }
            }
            this.$HTTP.post(`/api/blade-mdc/time-used-analysis/workstation/shiftName`,obj).then(res=> {
                if(res.code == 200) {
                    this.setTitle = res.data.shiftDetails;
                    res.data.shiftDetails.forEach(item=> {
                        this.activeNames.push(item.shiftIndex);  //默认都是全部展开
                        this.getDataChartsA(item.shiftIndex);  //渲染charts
                    })
                }
            })
        },
        formatChartData(originalObject) {
            var resultObject = originalObject.reduce(function(acc, currArray) {  
                currArray.forEach(function(item) {  
                    // 如果acc中还没有这个statusName的键，则初始化一个空数组  
                    if (!acc[item.statusName]) {  
                        acc[item.statusName] = [];  
                    }  
                    // 将count值添加到对应statusName的数组中  
                    acc[item.statusName].push(item.count);  
                });  
                return acc;  
            }, {}); // 第二个参数{}是accumulator的初始值  
            // 计算每个状态的时间总和  
            var timeSums = Object.values(resultObject).reduce((acc, curr) => {  
                return acc.map((sum, index) => sum + curr[index]);  
            }, new Array(Object.values(resultObject)[0].length).fill(0));  
            
            // 排除运行时间为0的情况  
            var totalRunTime = timeSums[0] || 1;  
            // 计算每个状态的百分比数据  
            // var lastData = Object.keys(resultObject).map(key => {  
            //     var data = resultObject[key].map((item, index) => {  
            //         if (index === 0) { // 只计算时间的百分比  
            //             return item == 0?0:Number((item / totalRunTime * 100).toFixed(2));
            //         } else {  
            //             return item; // 计数保持不变  
            //         }  
            //     });  
            //     return {
            //         name: key,
            //         type: 'bar',
            //         stack: 'total',
            //         label: {
            //             show: false
            //         },
            //         emphasis: {
            //             focus: 'series'
            //         },
            //         barWidth: 60,
            //         data
            //     }
            // }); 
            var lastData = [];
            var colorObj = {};  //设置颜色
            this.getGlobalColorList.forEach(item=> {
                colorObj[item.name] = item.color;
            })
            Object.keys(resultObject).map(key => {
                resultObject[key].forEach((item,index)=> {
                    if(item != 0) {
                        var num = item/timeSums[index]* 100;
                        item = num.toFixed(2);
                    }
                    resultObject[key][index] = item;
                })
                lastData.push({
                    name: key,
                    type: 'bar',
                    stack: 'total',
                    label: {
                        show: false
                    },
                    emphasis: {
                        focus: 'series'
                    },
                    itemStyle: {
                        "color": colorObj[key]
                    },
                    barWidth: 60,
                    data: resultObject[key]
                })
            })
            return lastData.reverse();
        },
        getDataChartsA(index) {
            var obj = {
                enums: "SHIFT",
                groupCategory: 1,
                groupType: "group_workstation",
                ids: this.ids,
                month: moment(this.date).get('month') + 1,
                queryTime: this.date,
                shiftIndex: index,
                type: 0,
                week: moment(this.date).get('week'),
                year: moment(this.date).get('year')
            }
            if(this.btnLeftctive == 1) {  //按工位统计
                obj.type = 0;
            }else if(this.btnLeftctive == 2) { //按工位组统计
                obj.type = 1;
            }
            this.$HTTP.post(`/api/blade-mdc/time-used-analysis/work-stations?current=${this.current}&size=${this.size}`,obj).then(res=> {
                if(res.code == 200) {
                    var xAxis = [];
                    res.data.workStationDetails.forEach(item=> {
                        xAxis.push(item.name);
                    })
                    this.chartOptionA.xAxis.data = xAxis;
                    var recordDom = document.getElementById('recordwork' + index);
                    this.chartOptionA.series = this.formatChartData(res.data.countStatus);
                    var myChart = echarts.init(recordDom);
                    myChart.setOption(this.chartOptionA);
                    console.log(JSON.stringify(this.chartOptionA))
                }
            })
        },
        getDataChartsB(enums,month) {
            var obj = {
                enums: enums,
                groupCategory: 1,
                groupType: "group_workstation",
                ids: this.ids,
                month: moment(this.date).get('month') + 1,
                queryTime: this.date,
                type: 0,
                week: moment(this.date).get('week'),
                year: moment(this.date).get('year')
            }
            if(month) {
                obj.month = month;
            }
            if(this.btnLeftctive == 1) {  //按工位统计
                obj.type = 0;
            }else if(this.btnLeftctive == 2) { //按工位组统计
                obj.type = 1;
            }
            this.$HTTP.post(`/api/blade-mdc/time-used-analysis/work-stations?current=${this.current}&size=${this.size}`,obj).then(res=> {
                if(res.code == 200) {
                    var xAxis = [];
                    res.data.workStationDetails == null ? res.data.workStationDetails = [] : res.data.workStationDetails;
                    res.data.countStatus == null ? res.data.countStatus = [] : res.data.countStatus;
                    res.data.workStationDetails.forEach(item=> {
                        xAxis.push(item.name);
                    })
                    var option = "";
                    var index = 0;
                    if(enums == "DAY") {
                        option = "chartOptionB1";
                        index = 0;
                    }else if(enums == "MONTH") {
                        option = "chartOptionB2";
                        index = 2;
                    }else if(enums == "WEEK") {
                        option = "chartOptionB3";
                        index = 1;
                    }
                    this[option].xAxis.data = xAxis;
                    var recordDom = document.getElementById('chartsB' + index);
                    this[option].series = this.formatChartData(res.data.countStatus);
                    var myChart = echarts.init(recordDom);
                    myChart.setOption(this[option]);
                }
            })
        },
    	getTree2List() {  //按工位组统计
			this.$HTTP.get(`/api/blade-cps/group/tree?groupCategory=1&groupType=group_workstation`).then(res=> {
				if(res.code == 200) {
					this.tree2 = res.data;
				}
			})
		},
    	treeListNode(data,checked) {
            this.treeListNodeList = checked.checkedNodes;
    	},
    	changeLeftTab(item) {
    		this.btnLeftctive = item.id;
            this.ids = [];
    	},
        tabChange(val) {
            this.activeName = val;
            if(val == "time") {  //按时间周期统计
                if(this.setTitle.length != 0) {
                    var obj = {
                        endDate: this.btnList[0].id,
                        startDate: this.btnList[0].id,
                        statisticalMethod: "WEEK"
                    }
                    this.$HTTP.post(`/api/blade-mdc/efficiency-analysis/interval`,obj).then(res=> {
                        if(res.code == 200) {
                            var dateInJuly = moment(this.btnList[0].id);  
                            // 获取该月份的第一天  
                            var firstDayOfJuly = dateInJuly.startOf('month').format('YYYY-MM-DD');  
                            // 获取该月份的最后一天  
                            var lastDayOfJuly = dateInJuly.endOf('month').format('YYYY-MM-DD'); 
                            //跨月
                            var startDate = moment(res.data[0].startDate).month() + 1;
                            var endDate = moment(res.data[0].endDate).month() + 1;
                            var arrMonth = [];
                            for (var i = startDate; i <= endDate; i++) {
                                arrMonth.push({title: (i + "月"),id: (i + "月")});
                            }
                            var arr = [];
                            arr.push({
                                btnList: this.btnList,
                                name: '按日查看',
                                btnListActive: this.btnList[0].id
                            },{
                                btnList: [{title:moment(this.date).get('week') + "周",id: moment(this.date).get('week') + "周"}],
                                name: '按周查看',
                                btnListActive: moment(this.date).get('week') + "周",
                                indexName : res.data[0].startDate + "至" + res.data[0].endDate
                            },{
                                btnList: arrMonth.reverse(),
                                name: '按月查看',
                                btnListActive: moment(this.date).get('month') + 1 + "月",
                                indexName : firstDayOfJuly + "至" + lastDayOfJuly
                            });
                            this.setTitle1 = arr;
                            this.getDataChartsB("DAY");
                            this.getDataChartsB("MONTH");
                            this.getDataChartsB("WEEK");
                        }
                    })
                }
            }else if(val == "shift") {  //按班次统计

            }
        },
        exportData() {  //导出
            var obj = {
                endTime: this.time[1],
                startTime: this.time[0],
                workstationInfoList: this.workstationInfoList
            }
            this.$HTTP.post(`/api/blade-mdc/status-record/excel/export`,obj).then(res=> {
                if(res.code == 200) {
                    window.open(res.data.link);
                }
            })
        },
        changeTab(item) {
            this.btnListActive = item.id;
            this.date = item.id;
            this.getDataA();
        },
        changeTabB(item,index,index1) {
            this.setTitle1[index].btnListActive = item.id;
            this.date = this.setTitle1[0].btnListActive;
            if(index == 0) {
                this.getDataChartsB("DAY");
            }
            if(index == 1) {
                this.getDataChartsB("WEEK");
            }
            if(index == 2) {  //月
                this.getDataChartsB("MONTH",this.setTitle1[2].btnListActive.split("月")[0]);
            }
        },
        getTime(data) {
            this.$HTTP.post('/api/blade-mdc/efficiency-analysis/interval', {
                ...data
            }).then(res => {
                if (res.code === 200) {
                    var today =  moment().format('YYYY-MM-DD');
                    var yesterday = moment().subtract(1, 'days').format('YYYY-MM-DD');
                    res.data.forEach(item=> {
                        if(item.title == today) {
                            item.title = "今天";
                        }
                        if(item.title == yesterday) {
                            item.title = "昨天";
                        }
                    })
                    this.btnList = res.data.reverse();
                    this.btnListActive = res?.data?.[0]?.id
                }
            })
        },
        init() {
            this.time = [moment().subtract(2, 'days').format('YYYY-MM-DD'), moment().format('YYYY-MM-DD')];
            this.getTime({endDate: this.time[1],startDate: this.time[0],statisticalMethod: 'SHIFT'});  //日期sort
            this.date = this.time[1];
        },
        query() {
            console.log(this.activeName)
            this.getTime({endDate: this.time[1],startDate: this.time[0],statisticalMethod: 'SHIFT'});
            this.date = this.time[1];
            this.ids = [];
            if(this.btnLeftctive == 1) {  //按工位统计
                this.treeChecked.forEach(item=> {
                    this.ids.push(item.id);
                })
            }else if(this.btnLeftctive == 2) { //按工位组统计
                this.treeListNodeList.forEach(item=> {
                    this.ids.push(item.id);
                })
            }
            if(this.activeName == "shift") {  //按班次统计
                this.getDataA();
            }else if(this.activeName == "time") { //按周期统计
                this.getDataChartsB("DAY");
                this.getDataChartsB("WEEK");
                this.getDataChartsB("MONTH",this.setTitle1[2].btnListActive.split("月")[0]);
            }
        }
    }
}
</script>

<style scoped>
    .aposcope-main {
    	display: flex;
    	min-height: 100%;
    	margin: 8px;
    }
    .aposcope-left {
        position: relative;
    	width: 240px;
    	margin-right: 8px;
    	padding: 4px;
        height: 100%;
    	background-color: #fff;
        border-radius: 2px;
        overflow: hidden;
    }
    .aposcope-right {
    	flex: 1;
    	padding: 8px;
    	background-color: #fff;
    }
    .left-title {
    	font-size: 16px;
        text-align: center;
        height: 38px;
        line-height: 38px;
        border-bottom: 1px solid #e2e2e2;
        background-color: #409eff;
        color: #fff;
        border-radius: 2px 2px 0 0;
    }
    .left-title-col {
        margin-bottom: 8px;
        font-size: 14px;
        margin-top: 8px;
    }
    .footer {
        padding: 0px 32px;
        border-radius: 0 0 2px 2px;
        background: #fff;
        box-shadow: -1px 0 3px rgba(92, 92, 92, .16);
        height: 48px;
        display: flex;
        align-items: center;
        justify-content: center;
        position: absolute;
        bottom: 0;
        left: 0;
        width: 100%;
        padding: 0 10px;
        box-sizing: border-box;
        z-index: 99;
    }
    .MYTree {
    	margin-top:12px;
        height: 600px;
    }
    .MYTree-content {
        height: 100%;
        overflow: hidden;
        overflow-y: auto;
    }
    .status {
        display: flex;
        align-items: start;
        flex-direction: column;
        justify-content: start;
        margin: 20px 0 8px;
        position: relative;
    	width: 100%;
    	font-size: 16px;
    	cursor: pointer;
    }
    .fact-analysis-realtim {
        display: flex;
        flex-direction: row;
        flex-wrap: wrap;
        justify-content: flex-start;
        align-content: flex-start;
        box-sizing: border-box;
        background: #fff;
        height: 500px;
    }
    .wimi-empty {
        height: 100%;
        width: 100%;
        display: flex;
        border-radius: 2px;
        flex-direction: column;
        flex-wrap: nowrap;
        align-content: center;
        justify-content: center;
        align-items: center;
    }
    .empty-description {
        margin-bottom: 20px;
        font-size: 14px;
        color: #5e6d82;
        margin-top: -16px;
        line-height: 28px;
    }
    .demo-collapse {
    
    }
    .collr-title {
        margin-left:8px;
        margin-right: 8px;
        font-weight: bold;
    }
    .demo-collapse /deep/ .el-collapse-item__header {
        background-color: #d8e8e8;
        margin: 8px;
        height: 32px;
        padding-left: 16px;
        border-radius: 4px;
    }
    .demo-collapse /deep/ .el-collapse-item__content {
        margin: 8px;
        padding-left: 16px;
    }
</style>